import Base from './base';
import { DataRequest, InitConfigFork } from './types';
export default class Fork extends Base {
    private Forks;
    private isFirstFork;
    protected configForks: Map<string, InitConfigFork>;
    /**
     * Metodo que hace rel registro de Forks
     * para su utilizacion sobre los servicios.
     * @param conf Configuracion para el evento
     */
    forksConfig(conf: InitConfigFork[]): void;
    /**
     * Metodo que procesa los mensajes
     * @param data Datos
     * @param Method Metodo que se ejecutara
     */
    message(data: DataRequest, Method: any, params?: string[]): Promise<any>;
    /**
     * Metodo para recuperar el data que se ejecutara
     * @param dataDefault Data por default
     * @param conf Configuracion del fork
     * @param response Datos del servicio previo
     */
    private getData;
    /**
     * Metodo para crear la estructura para la publicacion
     * del mensaje.
     * @param worker Configuracion del worker
     */
    private getNextTopic;
    /**
     * Metodo para buscar la posicion del siguiente
     * Fork a ejecutar
     * @param nameFork Nombre que se busca
     */
    private nextFork;
    /**
     * Metodo para asergurar si ocurrio un error al momento de consumir el servicio
     * @param data Datos a procesar
     */
    private isError;
    /**
     * Metodo para recuperar el error code
     * @param data Data a procesar
     */
    private getErrorCode;
    /**
     * Metodo para crear el error Meta que se pasa como mensaje de error.
     *
     * @private
     * @param {DataRequest} data
     * @returns {ErrorMetadata}
     * @memberof Fork
     */
    private getErrorMeta;
    /**
     * Metodo apra aplicar los cambios sobre
     * la metadata
     * @param data Data a cambiar
     * @param current Worker Actual
     */
    private changeMetadata;
}
