import 'reflect-metadata';
import { ConfFork, ConfService } from './types';
/**
 * Clase para la definicion y manejo del microservicio.
 */
export declare class MsManager {
    /**
     * Manejador de logs
     * @protected
     */
    static logs: any;
    /**
     * Metodo que ejecuta una clase
     * @param Target Clase a ejecutar
     */
    static execute(Target: any): void;
    /**
     * Metodo para el el registro del micro servicio
     * @param Conf Configuracion del microservicio
     */
    static Define(Conf: ConfService): any;
    /**
     * @public
     * @static
     */
    static List(forks?: ConfFork[]): any;
    /**
     * @public
     * @static
     */
    static Create(forks?: ConfFork[]): any;
    /**
     * @public
     * @static
     */
    static Get(forks?: ConfFork[]): any;
    /**
     * @public
     * @static
     */
    static Update(forks?: ConfFork[]): any;
    /**
     * @public
     * @static
     */
    static Delete(forks?: ConfFork[]): any;
    /**
     * @public
     * @static
     */
    static Listener(forks?: ConfFork[]): any;
    /**
     * Metodo para definir la configuracion de los Forks
     */
    static Fork(): any;
    static Errors(): any;
    /**
     * Metodo para el registro Raw de un elemento de clase
     * @param conf Configuracion del elemento
     * @param type Tipo del elemento
     * @param isFunction Indicar si se espera una funcion
     * @param confMethod Configuracion del elemento decorado
     */
    static defineElement(Type: string, isFunction?: boolean, confMethod?: any): any;
    /**
     * Metodo para recuperar toda la Meta data de un target
     * @param Target
     */
    static getAllMetaData(Target: any): object[];
    /**
     * metodo para recuperar los datos desde el contexto
     * de la aplicacion.
     * @param name Nombre del elemento
     */
    static ctx(name: string): (target: any, propertyKey: string, parameterIndex: number) => void;
}
