import { ConfService } from './types';
/**
 *  Clase para realizar un wrapper de la
 *  publicacion de logs sobre la cola
 *  de mensajes.
 */
export default class Logs {
    /**
     * Metodo encargado de enviar el mensaje de logs
     * @private
     */
    private send;
    /**
     * Configuracion del servicio
     * @private
     */
    private conf;
    /**
     * Contructor de clase
     * @param send metodo send original
     * @param conf Configuracion del servicio
     * @constructor
     */
    constructor(send: any, conf: ConfService);
    /**
     * Metodo para publicar un logs de tipo trace.
     * @param arg Arugmentos del loggers
     */
    trace(...arg: any): void;
    /**
     * Metodo para publicar un logs de tipo debug.
     * @param arg Arugmentos del loggers
     */
    debug(...arg: any): void;
    /**
     * Metodo para publicar un logs de tipo info.
     * @param arg Arugmentos del loggers
     */
    info(...arg: any): void;
    /**
     * Metodo para publicar un logs de tipo warning.
     * @param arg Arugmentos del loggers
     */
    warn(...arg: any): void;
    /**
     * Metodo para publicar un logs de tipo error.
     * @param arg Arugmentos del loggers
     */
    error(...arg: any): void;
    /**
     * Metodo para publicar un logs de tipo fatal.
     * @param arg Arugmentos del loggers
     */
    fatal(...arg: any): void;
    /**
     * Metodo para realizar la publicacion de un logs
     * @param type Tipo del logs
     * @param arg Argumentos extra
     */
    private publish;
}
